import 'dart:io';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

const VIEW_TYPE = 'com.amap.flutter.map';
class NanMapWidget extends StatefulWidget{

  final String apiKey;
  final bool isHiddenHead;//是否隐藏头部位置,默认不隐藏
  final Function returnResult;
  final NanMapController controller;
  NanMapWidget({
    Key key,
    @required this.apiKey,
    this.returnResult,
    this.controller,
    this.isHiddenHead = false,//
  }):super(key: key);

  @override
  _NanMapWidgetState createState() => _NanMapWidgetState();
}
class _NanMapWidgetState extends State<NanMapWidget>{
  MethodChannel _channel;

  @override
  void initState() {
    super.initState();

  }

  @override
  void dispose() {
    super.dispose();

  }

  @override
  Widget build(BuildContext context) {

    return Platform.isIOS?UiKitView(
      viewType: VIEW_TYPE,
      // onPlatformViewCreated: onPlatformViewCreated,
      // gestureRecognizers: gestureRecognizers,
      creationParams: creationParams(),
      onPlatformViewCreated: _onPlatformViewCreated,
      creationParamsCodec: const StandardMessageCodec(),
    ):AndroidView(
      viewType: VIEW_TYPE,
      creationParams: creationParams(),
      onPlatformViewCreated: _onPlatformViewCreated,
      creationParamsCodec: const StandardMessageCodec(),
    );
  }

  void _onPlatformViewCreated(int id) {
    _channel = MethodChannel('map_message_channel_$id');
    _channel?.setMethodCallHandler((MethodCall call) async {
      if (call.method == 'returnResult') {
        if (widget.returnResult != null)
          widget.returnResult(call.arguments);
      }
    });
    widget.controller?._channel = _channel;
  }

  Map<String, dynamic> creationParams(){
    return <String, dynamic>{
      'apiKey': widget.apiKey,
      'isHidden': widget.isHiddenHead?"0":'1'
    };
  }
}

class NanMapController {
  MethodChannel _channel;

  NanMapController();

  void currentPosition() {
    _channel?.invokeMethod("currentPosition");
  }

  void setMapType({int mapType=1}) {
    _channel.invokeMethod("setMapType",mapType);
  }
}